<?php
namespace XenGenTr\ForumistatistikPlus\Admin\Controller;

class SabitKonu extends \XF\Admin\Controller\AbstractController
{
    protected function preDispatchController($action, \XF\Mvc\ParameterBag $params)
    {
        $this->assertAdminPermission("xgtForumIstatistik_sabit");
    }
    public function actionIndex(\XF\Mvc\ParameterBag $params)
    {
        $page = $this->filterPage();
        $perPage = 100;
        $sabitkonuRepo = $this->getSabitKonuRepo();
        $entries = $sabitkonuRepo->findSabitKonu();
        $entries->limitByPage($page, $perPage);
        $filter = $this->filter("_xfFilter", ["text" => "str", "prefix" => "bool"]);
        $viewParams = ["sabitkonular" => $entries->fetch(), "total" => $entries->total(), "page" => $page, "perPage" => $perPage, "filter" => $filter["text"]];
        return $this->view("XenGenTr\\ForumistatistikPlus:SabitKonu\\List", "xgt_FrmIstatistik_sabitKonular_liste", $viewParams);
    }
    public function actionDuzenle(\XF\Mvc\ParameterBag $params)
    {
        $thread = $this->assertThreadExists($params->thread_id);
        $sabitkonu = $this->assertSabitKonuExists($params->thread_id);
        $viewParams = ["thread" => $thread, "sabitkonu" => $sabitkonu];
        return $this->view("XenGenTr\\ForumistatistikPlus:SabitKonu\\Duzenle", "xgt_FrmIstatistik_sabitKonular_duzenle", $viewParams);
    }
    public function actionSave(\XF\Mvc\ParameterBag $params)
    {
        $sabitkonu = $this->assertSabitKonuExists($params->thread_id, "Thread");
        $input = $this->filter("sabitkonu", "array");
        $input = $this->filter(["display_order" => "uint", "active" => "bool"]);
        $date = $this->filter("date", "datetime");
        $dateTime = new \DateTime("@" . $date);
        $input["bitis_zamani"] = $dateTime->getTimestamp();
        $form = $this->formAction();
        $form->basicEntitySave($sabitkonu, $input);
        $form->run();
        return $this->redirect($this->buildLink("sabit-konu/konular"));
    }
    public function actionSil(\XF\Mvc\ParameterBag $params)
    {
        $sabitkonu = $this->assertSabitKonuExists($params->thread_id, "Thread");
        $plugin = $this->plugin("XF:Delete");
        return $plugin->actionDelete($sabitkonu, $this->buildLink("sabit-konu/konular/sil", $sabitkonu), $this->buildLink("sabit-konu/konular/duzenle", $sabitkonu), $this->buildLink("sabit-konu/konular"), $sabitkonu->Thread->title);
    }
    protected function assertSabitKonuExists($id, $with = NULL, $phraseKey = NULL)
    {
        return $this->assertRecordExists("XenGenTr\\ForumistatistikPlus:SabitKonu", $id, $with, $phraseKey);
    }
    protected function assertThreadExists($id, $with = NULL, $phraseKey = NULL)
    {
        return $this->assertRecordExists("XF:Thread", $id, $with, $phraseKey);
    }
    protected function getSabitKonuRepo()
    {
        return $this->repository("XenGenTr\\ForumistatistikPlus:SabitKonu");
    }
}

?>