<?php
namespace XenGenTr\ForumistatistikPlus\Pub\Controller;

class LicenseApi extends AbstractControllerApi
{
    public function actionGet()
    {
        $user = $this->assertValidApiKey();
        $categoryIds = $this->filter("category_ids", "array-uint");
        $licenseRepo = $this->repository("XenGenTr\\ForumistatistikPlus:License");
        $licenseFinder = $licenseRepo->findLicensesByUser($user->user_id, $categoryIds ?: NULL, ["allowOwnPending" => false]);
        $platformFilters = $this->filter("platforms", "array-str");
        if($platformFilters) {
            $filterAssociations = $this->finder("XenGenTr\\ForumistatistikPlus:SabitKonular")->where("filter_id", $platformFilters);
            $licenseFinder->where("product_id", $filterAssociations->fetch()->pluckNamed("product_id", "product_id"));
        }
        $licenseCollection = $licenseFinder->fetch();
        $licenseCollection = $licenseRepo->filterLicensesForApiResponse($licenseCollection);
        $licenses = [];
        foreach ($licenseCollection as $licenseEntity) {
            $license = $licenseEntity->toArray(false);
            $license["Product"] = $licenseEntity->Product->toArray(false);
            $license["Product"]["full_title"] = $licenseEntity->Product->getFullTitle();
            $license["Product"]["tagline"] = $licenseEntity->Product->getTagline();
            $license["Product"]["product_page_url"] = $this->router()->buildLink("canonical:sabit-konular", $licenseEntity->Product);
            $license["LatestVersion"] = $licenseEntity->Product->LatestVersion->toArray(false);
            $licenses[$license["license_id"]] = $license;
        }
        return $this->toApiResults(["licenses" => $licenses]);
    }
}

?>