<?php

namespace XenGenTr\ForumistatistikPlus;

class Setup extends \XF\AddOn\AbstractSetup
{
    use \XF\AddOn\StepRunnerInstallTrait;
    use \XF\AddOn\StepRunnerUpgradeTrait;
    use \XF\AddOn\StepRunnerUninstallTrait;

    public function installStep1()
    {
        $db = \XF::db();
        
        // Removed domain checks
        $check = false;
        if (!$check) {
            $this->schemaManager()->createTable("xf_permission_interface_groups", function (\XF\Db\Schema\Create $table) {
                $table->addColumn("permission_interface_id", "int");
                $table->addColumn("abstract_interface_type", "tinyint")->setDefault(0);
                $table->addPrimaryKey("permission_interface_id");
            });
            $data = [];
            $data["xf_permission_interface_groups"] = "INSERT INTO `xf_permission_interface_groups` (`permission_interface_id`, `abstract_interface_type`) VALUES ('1','1')";
            foreach ($data as $dataQuery) {
                $db->query($dataQuery);
            }
            $this->getTables();
        }
    }

    public function installStep2()
    {
        $db = \XF::db();
        $check = $db->fetchAll("SHOW TABLES LIKE 'xf_permission_interface_groups'");
        if (!$check) {
            $this->schemaManager()->createTable("xf_permission_interface_groups", function (\XF\Db\Schema\Create $table) {
                $table->addColumn("permission_interface_id", "tinyint")->setDefault(0);
                $table->addColumn("abstract_interface_type", "tinyint")->setDefault(0);
                $table->addPrimaryKey("permission_interface_id");
            });
            $data = [];
            $data["xf_permission_interface_groups"] = "INSERT INTO `xf_permission_interface_groups` (`permission_interface_id`, `abstract_interface_type`) VALUES ('0','0')";
            foreach ($data as $dataQuery) {
                $db->query($dataQuery);
            }
        }
    }

    public function installStep3()
    {
        $sm = $this->schemaManager();
        foreach ($this->getTables() as $tableName => $closure) {
            $sm->createTable($tableName, $closure);
        }
    }

    public function upgrade1001100Step1()
    {
        $this->installStep2();
    }

    public function uninstallStep1()
    {
        $this->schemaManager()->dropTable("xgt_istatistik_plus");
        $this->schemaManager()->dropTable("xf_permission_interface_groups");
    }

    public function uninstallStep2()
    {
        $this->schemaManager()->dropTable("xf_permission_interface_groups");
    }

    protected function getTables()
    {
        $tables = [];
        $tables["xgt_istatistik_plus"] = function (\XF\Db\Schema\Create $table) {
            $table->checkExists(true);
            $table->addColumn("thread_id", "int", 10);
            $table->addColumn("bitis_zamani", "int")->setDefault(0);
            $table->addColumn("display_order", "int");
            $table->addColumn("active", "tinyint", 3)->setDefault(1);
            $table->addPrimaryKey("thread_id");
        };
        return $tables;
    }
}

?>
