<?php
namespace XenGenTr\ForumistatistikPlus\XF\Pub\Controller;

class Thread extends XFCP_Thread
{
    public function actionIndex(\XF\Mvc\ParameterBag $params)
    {
        $reply = parent::actionIndex($params);
        if(!$reply instanceof \XF\Mvc\Reply\View) {
            return $reply;
        }
        $thread = $reply->getParam("thread");
        return $reply;
    }
    public function actionSabitKonuDuzenle(\XF\Mvc\ParameterBag $params)
    {
        if(!\XF::visitor()->hasPermission("XGT_istatistik_izin_grubu", "konuSabitleyebilir")) {
            return $this->noPermission();
        }
        $thread = $this->assertViewableThread($params->thread_id);
        $sabitkonu = $thread->SabitKonu;
        if($sabitkonu && !$sabitkonu->canDuzenleyebilir()) {
            return $this->noPermission();
        }
        if($this->isPost()) {
            if(!$sabitkonu) {
                $sabitkonu = $this->em()->create("XenGenTr\\ForumistatistikPlus:SabitKonu");
            }
            $input = $this->filter("sabitkonu", "array");
            $input = $this->filter(["display_order" => "uint"]);
            $input["thread_id"] = $thread->thread_id;
            $date = $this->filter("date", "datetime");
            $dateTime = new \DateTime("@" . $date);
            $input["bitis_zamani"] = $dateTime->getTimestamp();
            $form = $this->formAction();
            $form->basicEntitySave($sabitkonu, $input);
            $form->run();
            return $this->redirect($this->buildLink("threads", $thread));
        }
        $viewParams = ["thread" => $thread, "sabitkonu" => $sabitkonu];
        return $this->view("XenGenTr\\ForumistatistikPlus:Thread\\SabitKonuDuzenle", "xgt_FrmIstatistik_sabitKonular_duzenle", $viewParams);
    }
    public function actionSabitKonuSil(\XF\Mvc\ParameterBag $params)
    {
        $sabitkonu = $this->assertSabitKonuExists($params->thread_id, "Thread");
        if(!$sabitkonu->canDuzenleyebilir()) {
            return $this->noPermission();
        }
        if(!$sabitkonu->preDelete()) {
            return $this->error($sabitkonu->getErrors());
        }
        if($this->isPost()) {
            $sabitkonu->delete();
            return $this->redirect($this->buildLink("threads", $sabitkonu));
        }
        $viewParams = ["sabitkonu" => $sabitkonu];
        return $this->view("XenGenTr\\ForumistatistikPlus:SabitKonu\\Sil", "xgt_FrmIstatistik_sabitKonular_sil", $viewParams);
    }
    protected function assertSabitKonuExists($id, $with = NULL, $phraseKey = NULL)
    {
        return $this->assertRecordExists("XenGenTr\\ForumistatistikPlus:SabitKonu", $id, $with, $phraseKey);
    }
}

?>