<?php
namespace XenGenTr\XGTCoreLibrary\Admin\Controller;

class License extends \XF\Admin\Controller\AbstractController
{
    public function actionIndex(\XF\Mvc\ParameterBag $params)
    {
        $licenseRepo = $this->getLicenseRepo();
        $licenseFinder = $licenseRepo->findLicenseForList();
        $page = $params->page;
        $perPage = 30;
        $licenseFinder->limitByPage($page, $perPage);
        $viewParams = ["license_lists" => $licenseFinder->fetch(), "page" => $page, "perPage" => $perPage, "total" => $licenseFinder->total()];
        return $this->view("XenGenTr\\XGTCoreLibrary:License\\List", "xgt_license_list", $viewParams);
    }
    protected function preDispatchController($action, \XF\Mvc\ParameterBag $params)
    {
        $this->assertSuperAdmin();
        $this->assertPasswordVerified(1800);
    }
    public function actionEdit(\XF\Mvc\ParameterBag $params)
    {
        $xgt_api_id = $params["xgt_api_id"];
        $licenseEditRepo = $this->getLicenseRepo();
        $licenseEditFinder = $licenseEditRepo->findLicenseEditForList($xgt_api_id);
        $viewParam = ["license_lists" => $licenseEditFinder];
        return $this->view("XenGenTr\\XGTCoreLibrary:view", "xgt_license_edit", $viewParam);
    }
    public function actionUpdate()
    {
        $db = \XF::db();
        $xgt_api_id = $this->filter("xgt_api_id", "int");
        $all_values = ["product_key" => $this->filter("product_key", "str"), "license_key" => $this->filter("license_key", "str")];
        if($all_values && $xgt_api_id) {
            $db->update("xf_xgt_api_listesi", $all_values, "xgt_api_id  =  ?", [$xgt_api_id]);
            return $this->redirect($this->buildLink("xgt-license-list"), "successfully", "permanent");
        }
        return $this->message(\XF::phrase("xgt_api_list_update_error"));
    }
    protected function assertLicenseExists($id, $with = NULL, $phraseKey = NULL)
    {
        return $this->assertRecordExists("XenGenTr\\XGTCoreLibrary:License", $id, $with, $phraseKey);
    }
    protected function getLicenseRepo()
    {
        return $this->repository("XenGenTr\\XGTCoreLibrary:License");
    }
}

?>