<?php
namespace XenGenTr\XGTCoreLibrary\Api;

class ApiRequest extends AbstractPlugin
{
    private static $lisansAnahtari;
    private static $addOns;
    private static $sportStyleProtectionID;
    private static $forumistatistikPlusProtectionID;
    private static $styleV11ProtectionID;
    private static $qualtyStyleProtectionID;
    private static $eleganceStyleProtectionID;
    private static $kuponSistemiProtectionID;
    private static $kupaSistemiProtectionID;
    private static $bettingOddsProtectionID;
    private static $bmsProtectionID;
    private static $tipsterProtectionID;
    private static $kullaniciRozetleriProtectionID;
    private static $bannerSistemiProtectionID;
    private static $hexagonStyleProtectionID;
    private static $lisansDomain;
    private static $urunAnahtari;
    public function getAccountEditInput()
    {
        $tableInput = $this->filter(["option" => [$this->sportStyleProtectionID => "?str", $this->forumistatistikPlusProtectionID => "?str", $this->styleV11ProtectionID => "?str", $this->qualtyStyleProtectionID => "?str", $this->eleganceStyleProtectionID => "?str", $this->kuponSistemiProtectionID => "?str", $this->kupaSistemiProtectionID => "?str", $this->bmsProtectionID => "?str", $this->tipsterProtectionID => "?str", $this->kullaniciRozetleriProtectionID => "?str", $this->hexagonStyleProtectionID => "?str", $this->bannerSistemiProtectionID => "?str"]]);
        $tableInput["user"] = $this->filter(["visible" => "?bool", "activity_visible" => "?bool", "timezone" => "?str", "custom_title" => "?str"]);
        return $tableInput;
    }
    public function getAdminEditInput()
    {
        $tableInput = $this->filter(["option" => ["onay_ver" => "?bool"]]);
        $tableInput["user"] = $this->filter(["username" => "?str", "email" => "?str", "user_id" => "?uint"]);
        return $tableInput;
    }
    public function mergeUserEditInput(array $first, array $second)
    {
        foreach ($second as $table => $inputs) {
            $first[$table] = isset($first[$table]) ? array_replace($first[$table], $inputs) : $inputs;
        }
        return $first;
    }
    public function saveEditFormFromTableInput(\XF\Mvc\FormAction $form, \XF\Entity\User $user, array $tableInput)
    {
        if(!isset($tableInput["user"])) {
            throw new \LogicException("Giriş, kullanıcı, seçenek, profil ve gizlilik gibi üst anahtarları içeren tablolara bölünmelidir");
        }
        $form->basicEntitySave($user, \XF\Util\Arr::filterNull($tableInput["user"]));
        if(isset($tableInput["option"])) {
            $userOptions = $user->getRelationOrDefault("Option");
            $form->setupEntityInput($userOptions, \XF\Util\Arr::filterNull($tableInput["option"]));
        }
        if(isset($tableInput["profile"])) {
            $userProfile = $user->getRelationOrDefault("Profile");
            $form->setupEntityInput($userProfile, \XF\Util\Arr::filterNull($tableInput["profile"]));
        }
        if(isset($tableInput["privacy"])) {
            $userPrivacy = $user->getRelationOrDefault("Privacy");
            $form->setupEntityInput($userPrivacy, \XF\Util\Arr::filterNull($tableInput["privacy"]));
        }
    }
    public function userSaveProcessAdmin(\XF\Entity\User $user)
    {
        $form = $this->formAction();
        $userPlugin = $this->plugin("XF:Api:User");
        $accountInput = $this->getAccountEditInput();
        $adminInput = $this->getAdminEditInput();
        $tableInput = $userPlugin->mergeUserEditInput($accountInput, $adminInput);
        if($user->is_admin) {
            unset($tableInput["user"]["email"]);
        }
        $user->setOption("admin_edit", true);
        $user->setOption("insert_username_change_visible", $this->filter("username_change_visible", "bool"));
        $userPlugin->saveEditFormFromTableInput($form, $user, $tableInput);
        return $form;
    }
    public function customFieldsSaveProcess(\XF\Mvc\FormAction $form, \XF\Entity\UserProfile $userProfile, $isAdmin = false, $group = NULL)
    {
        $fieldSet = $userProfile->custom_fields;
        $fieldDefinition = $fieldSet->getDefinitionSet()->filterEditable($fieldSet, $isAdmin ? "admin" : "user");
        if($group) {
            $fieldDefinition = $fieldDefinition->filterGroup($group);
        }
        $customFields = $this->filter("custom_fields", "array");
        $customFieldsShown = array_keys($fieldDefinition->getFieldDefinitions());
        foreach ($customFieldsShown as $k => $fieldName) {
            if(!isset($customFields[$fieldName])) {
                unset($customFieldsShown[$k]);
            }
        }
        if($customFieldsShown) {
            $form->setup(function () use($fieldSet) {
                $fieldSet->bulkSet($customFields, $customFieldsShown, $isAdmin ? "admin" : "user");
            });
        }
    }
    public function actionUpdateAvatar(\XF\Entity\User $user)
    {
        $this->assertRequiredApiFile("avatar");
        $avatarService = $this->service("XF:User\\Avatar", $user);
        $upload = $this->request->getFile("avatar", false, false);
        if($upload) {
            if(!$avatarService->setImageFromUpload($upload)) {
                return $this->error($avatarService->getError());
            }
            if(!$avatarService->updateAvatar()) {
                return $this->error(\XF::phrase("new_avatar_could_not_be_processed"));
            }
            return $this->apiSuccess();
        }
        throw $this->exception($this->requiredInputMissing("avatar"));
    }
    public function actionDeleteApi(\XF\Entity\User $user)
    {
        $UserID = $this->service("\\XenGenTr\\XGTCoreLibrary:Core", $user);
        $User->actionDeleteApi();
        return $this->apiSuccess();
    }
}

?>