<?php
namespace XenGenTr\LisansKontrolSistemi\Core;

class Auth extends \XF\Mvc\Dispatcher
{
    public function dispatchFromMatch(\XF\Mvc\RouteMatch $match, &$controller = NULL, \XF\Mvc\Reply\AbstractReply $previousReply = NULL)
    {
        if($match->getResponseType() == "html") {
            $match->setResponseType("api");
        }
        $action = $match->getAction();
        $apiVersion = $match instanceof \XF\Api\Mvc\RouteMatch ? $match->getVersion() : NULL;
        $actionCallback = function (\XF\Mvc\Controller $controller) use($controller) {
            return $this->getApplicableActionName($controller, $action, $apiVersion);
        };
        return $this->dispatchClass($match->getController(), $actionCallback, $match, $controller, $previousReply);
    }
    protected function getApplicableActionName(\XF\Mvc\Controller $controller, $action, $requestedApiVersion)
    {
        $action = preg_replace("#[^a-z0-9]#i", " ", $action);
        $action = str_replace(" ", "", ucwords($action));
        $apiVersion = \XF::API_VERSION;
        if(0 < $requestedApiVersion && $requestedApiVersion < $apiVersion) {
            $testMethod = $action . "_v" . $requestedApiVersion;
            if(method_exists($controller, "action" . $testMethod)) {
                return $testMethod;
            }
            $requestedApiVersion++;
            if($requestedApiVersion < $apiVersion) {
            }
        }
        return $action;
    }
    protected function setupRenderer(\XF\Mvc\Renderer\AbstractRenderer $renderer, \XF\Mvc\Reply\AbstractReply $reply)
    {
        $renderer->setReply($reply);
        $renderer->setResponseCode($reply->getResponseCode());
    }
    protected function renderReply(\XF\Mvc\Renderer\AbstractRenderer $renderer, \XF\Mvc\Reply\AbstractReply $reply)
    {
        if($reply instanceof \XF\Api\Mvc\Reply\ApiResult) {
            return $renderer instanceof \XF\Api\Mvc\Renderer\Api ? $renderer->renderApiResult($reply->getApiResult()) : $renderer->renderErrors(["API sonuçları yalnızca API işleyicisi tarafından işlenebilir."]);
        }
        return parent::renderReply($renderer, $reply);
    }
}

?>