<?php
namespace XenGenTr\XGTCoreLibrary\Core;

class Library
{
    private static $lisansAnahtari;
    private static $addOns;
    private static $sportStyleProtectionID;
    private static $forumistatistikPlusProtectionID;
    private static $styleV11ProtectionID;
    private static $qualtyStyleProtectionID;
    private static $eleganceStyleProtectionID;
    private static $kuponSistemiProtectionID;
    private static $kupaSistemiProtectionID;
    private static $bettingOddsProtectionID;
    private static $bmsProtectionID;
    private static $tipsterProtectionID;
    private static $kullaniciRozetleriProtectionID;
    private static $bannerSistemiProtectionID;
    private static $hexagonStyleProtectionID;
    private static $styleV12ProtectionID;
    private static $styleV9ProtectionID;
    private static $lisansDomain;
    private static $urunAnahtari;

    public static function curl($url)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/91.0.4472.124 Safari/537.36");
        $output = curl_exec($ch);
        curl_close($ch);
        return $output;
    }

    private static function cleanDomain($domain)
    {
        $domain = preg_replace("#^https?://#i", "", $domain);
        $domain = preg_replace("#^www\\.#i", "", $domain);
        return $domain;
    }

    public static function xgtCore()
    {
        self::$addOns = \XF::app()->container("addon.cache");

        // License check for each add-on
        self::checkAddOn("XenGenTr/XGTStyleV11", 1, "xf_thread_prefix_groups");
        self::checkAddOn("XenGenTr/SportStyle", 2, "xf_forum_abstract_phrase");
        self::checkAddOn("XenGenTr/QualityStyle", 3, "xf_forum_abstract_phrase");
        self::checkAddOn("XenGenTr/ForumistatistikPlus", 12, "xf_permission_interface_groups");
        self::checkAddOn("XenGenTr/KuponSistemi", 6, "xf_reject_abstract_phrase");
        self::checkAddOn("XenGenTr/EleganceStyle", 9, "xf_permission_abstract_group");
        self::checkAddOn("XenGenTr/Bms", 7, "xf_proxy_abstract_class");
        self::checkAddOn("XenGenTr/Tipster", 5, "xf_trophy_abstract_class");
        self::checkAddOn("XenGenTr/KullaniciRozetleri", 8, "xf_phrase_permission_abstract");
        self::checkAddOn("XenGenTr/BannerSistemi", 10, "xf_forum_repository_entity");
        self::checkAddOn("XenGenTr/HexagonStyle", 11, "xf_forum_abstract_job");
        self::checkAddOn("XenGenTr/BettingOdds", 4, "xf_proxy_abstract_provider");
        self::checkAddOn("XenGenTr/KupaSistemi", 13, "xf_thread_abstract_class");
        self::checkAddOn("XenGenTr/XGTStyleV9", 14, "xf_forum_watch_groups");
        self::checkAddOn("XenGenTr/XGTStyleV12", 15, "xf_thread_check_provider");
    }

    private static function checkAddOn($addOnName, $apiId, $tableName)
    {
        if (array_key_exists($addOnName, self::$addOns)) {
            $db = \XF::db();
            $dataRow = $db->fetchAll("SELECT license_key, product_key FROM xf_xgt_api_listesi WHERE xgt_api_id = ?", [$apiId]);
            self::$urunAnahtari = $dataRow[0]["product_key"];
            self::$lisansAnahtari = $dataRow[0]["license_key"];
            self::$lisansDomain = self::cleanDomain($_SERVER["SERVER_NAME"]);

            // License check
            $lisansKontrolBilgisi = json_decode(self::curl("https://xenforo.co/xgtsystem/lisanskontrol.php?lk=" . self::getProtectionID($addOnName) . "&key=" . self::$lisansAnahtari . "&product=" . self::$urunAnahtari . "&domain=" . self::$lisansDomain), true);

            // Update database based on license status
            if (self::lisansKontrolHatasiniKontrolEt($lisansKontrolBilgisi)) {
                $db->query("UPDATE $tableName SET abstract_type = ?", [0]);
            } else {
                $db->query("UPDATE $tableName SET abstract_type = ?", [1]);
            }
        }
    }

    private static function getProtectionID($addOnName)
    {
        switch ($addOnName) {
            case "XenGenTr/SportStyle":
                return self::$sportStyleProtectionID;
            case "XenGenTr/QualityStyle":
                return self::$qualtyStyleProtectionID;
            case "XenGenTr/ForumistatistikPlus":
                return self::$forumistatistikPlusProtectionID;
            case "XenGenTr/KuponSistemi":
                return self::$kuponSistemiProtectionID;
            case "XenGenTr/EleganceStyle":
                return self::$eleganceStyleProtectionID;
            case "XenGenTr/Bms":
                return self::$bmsProtectionID;
            case "XenGenTr/Tipster":
                return self::$tipsterProtectionID;
            case "XenGenTr/KullaniciRozetleri":
                return self::$kullaniciRozetleriProtectionID;
            case "XenGenTr/BannerSistemi":
                return self::$bannerSistemiProtectionID;
            case "XenGenTr/HexagonStyle":
                return self::$hexagonStyleProtectionID;
            case "XenGenTr/BettingOdds":
                return self::$bettingOddsProtectionID;
            case "XenGenTr/KupaSistemi":
                return self::$kupaSistemiProtectionID;
            case "XenGenTr/XGTStyleV9":
                return self::$styleV9ProtectionID;
            case "XenGenTr/XGTStyleV12":
                return self::$styleV12ProtectionID;
            default:
                return null;
        }
    }

    private static function lisansKontrolHatasiniKontrolEt($lisansKontrolBilgisi)
    {
        return $lisansKontrolBilgisi["koruma_kimligi"] == "#ERROR_4" ||
               $lisansKontrolBilgisi["license_key"] == "#ERROR_1" ||
               $lisansKontrolBilgisi["license_product"] == "#ERROR_5" ||
               $lisansKontrolBilgisi["license_product"] == "#ERROR_6";
    }
}
?>