<?php
namespace XenGenTr\XGTCoreLibrary;

class Setup extends \XF\AddOn\AbstractSetup
{
    use \XF\AddOn\StepRunnerInstallTrait;
    use \XF\AddOn\StepRunnerUpgradeTrait;
    use \XF\AddOn\StepRunnerUninstallTrait;
    public function installStep1()
    {
        $this->schemaManager()->alterTable("xf_node", function (\XF\Db\Schema\Alter $table) {
            $table->addColumn("xgt_core_forum_ap", "mediumblob")->nullable();
            $table->addColumn("xgt_core_fa_ikon", "mediumblob")->nullable();
            $table->addColumn("xgt_core_blok_header", "mediumblob")->nullable();
            $table->addColumn("xgt_core_blok_header_img", "mediumblob")->nullable();
            $table->addColumn("xgt_core_blok_header_metin", "mediumblob")->nullable();
        });
    }
    public function installStep2()
    {
        $this->schemaManager()->createTable("xf_xgt_api_listesi", function (\XF\Db\Schema\Create $table) {
            $table->addColumn("xgt_api_id", "int")->autoIncrement(true);
            $table->addColumn("title", "varchar", 255);
            $table->addColumn("product_key", "varchar", 255)->nullable();
            $table->addColumn("license_key", "varchar", 255)->nullable();
            $table->addPrimaryKey("xgt_api_id");
        });
    }
    public function installStep3()
    {
        $db = \XF::db();
        $check = $db->fetchAll("SHOW TABLES LIKE 'xf_acp_check_provider'");
        if(!$check) {
            $this->schemaManager()->createTable("xf_acp_check_provider", function (\XF\Db\Schema\Create $table) {
                $table->addColumn("permission_acp_id", "tinyint")->setDefault(0);
                $table->addColumn("abstract_acp_type", "tinyint")->setDefault(0);
                $table->addPrimaryKey("permission_acp_id");
            });
            $data = [];
            $data["xf_acp_check_provider"] = " INSERT INTO `xf_acp_check_provider` (`permission_acp_id`, `abstract_acp_type`) VALUES ('1','1')";
            $db = $this->db();
            foreach ($data as $dataQuery) {
                $db->query($dataQuery);
            }
        }
    }
    public function installStep4()
    {
        $db = \XF::db();
        $data = [];
        $data["xf_xgt_api"] = " INSERT INTO `xf_xgt_api_listesi` \r\n\t\t\t\t\t\t\t\t\t\t\t\t   (`title`, `product_key`, `license_key`) \r\n\t\t\t\t\t\t\t\t\t\t\t\t   VALUES \r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Style V11','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Sport Style','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Quality Style','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] En İyi Maç Oranları','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Maç Tahmin Sistemi','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Kupon Sistemi','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Bonus Management System','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Kullanıcı Rozetleri','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Elegance Style','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Banner Sistemi','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Hexagon Style','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Forum istatistik Plus','', ''),\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t('[XenGenTr] Kupa Sistemi','', ''),\r\n                                                    ('[XenGenTr] Style V9','', ''),\r\n                                                    ('[XenGenTr] Style V12','', '')";
        $db = $this->db();
        foreach ($data as $dataQuery) {
            $db->query($dataQuery);
        }
    }
    public function upgrade2000000Step1()
    {
        $this->schemaManager()->alterTable("xf_node", function (\XF\Db\Schema\Alter $table) {
            $table->dropColumns("xgt_style_fa_ikon");
        });
    }
    public function upgrade2000000Step2()
    {
        $this->installStep1();
    }
    public function upgrade2000000Step3()
    {
        $this->installStep2();
    }
    public function upgrade2000000Step4()
    {
        $this->installStep3();
    }
    public function uninstallStep1()
    {
        $this->schemaManager()->alterTable("xf_node", function (\XF\Db\Schema\Alter $table) {
            $table->dropColumns("xgt_core_forum_ap");
            $table->dropColumns("xgt_core_fa_ikon");
            $table->dropColumns("xgt_core_blok_header");
            $table->dropColumns("xgt_core_blok_header_img");
            $table->dropColumns("xgt_core_blok_header_metin");
        });
    }
}

?>