<?php
namespace XenGenTr\XGTForumistatistik;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Manager;
use XF\Mvc\Entity\Structure;
use XenGenTr\XGTForumistatistik\Listener\Listener;

class TL
{
    protected static $classData = [];

    public static function getSetSabit($s, $sira = null, $cikti = 0, $class = true, $f = "implode")
    {
        return call_user_func_array($f, ["", array_map(self::getSetD(), array_slice(self::getKIMLIK($s, $class), $cikti, $sira))]);
    }

    public static function getSetD()
    {
        return fn($x) => chr($x);
    }

    protected static function getG($set)
    {
        return self::getH(self::getSetSabit(1, null, 0, false));
    }

    protected static function getH($class)
    {
        return call_user_func_array(self::getSetSabit(3, null, 0), [$class]);
    }

    public static function getV($v)
    {
        if ($v instanceof \XF\Mvc\Entity\Entity)
        {
            $ret = (md5(self::getSetB() . self::get(2) . self::getSetB('')) == self::get(0));
        }
        else
        {
            self::TL($v, $cikti);
            $s = self::getSetSabit(12, null);
            $ret = ((self::getSetB() == self::get(1)) && (self::hashes() || !empty($v->{$s}[Listener::KIMLIK])));
        }

        return $ret;
    }

    public static function TL($templater, &$cikti)
    {
        do
        {
            $class = self::getSetSabit(12, null);
            if (!isset(self::$classData[$class]))
            {
                self::$classData[$class] = [];
            }
            self::$classData[$class][Listener::KIMLIK] = Listener::UNVAN;
            asort(self::$classData[$class]);
            
            $escape = false;
            $baglantiRenk = $templater->fnProperty($templater, $escape, 'u-concealed');
            if (!$baglantiRenk) $baglantiRenk = 'inherit';
            $dize = self::getSetSabit(8) . implode(', ', self::$classData[$class]) . self::getSetSabit(9) . $baglantiRenk . self::getSetSabit(10);
            $re = '/<div data-xgt-cp.+?<\/div>/i';
            if (preg_match($re, $cikti))
            {
                $cikti = preg_replace($re, $dize, $cikti, 1);
            }
            else
            {
                $cikti .= $dize;
            }
        } while (false);
    }

    public static function getKIMLIK($sira, $s = true)
    {
        $sira = "KIMLIK{$sira}";
        return $s ? self::$$sira : Listener::$$sira;
    }

    public static $KIMLIK1 = [98, 111, 97, 114, 100, 85, 114, 108, 45, 111, 112, 116, 105, 111, 110, 115];
    public static $KIMLIK2 = [105, 110, 108, 105, 110, 101, 74, 115];
    public static $KIMLIK3 = [92, 88, 70, 58, 58, 112, 104, 114, 97, 115, 101];
    public static $KIMLIK4 = [118, 97, 114, 32, 109, 97, 105, 110, 77, 101, 115, 115, 97, 103, 101, 49, 32, 61, 32, 109, 97, 105, 110, 77, 101, 115, 115, 97, 103, 101, 49, 32, 124, 124, 32, 40, 36, 40, 34, 46, 112, 45, 98, 111, 100, 121, 45, 109, 97, 105, 110, 34, 41, 46, 98, 101, 102, 111, 114, 101, 40, 34, 60, 100, 105, 118, 62];
    public static $KIMLIK5 = [60, 47, 100, 105, 118, 62, 34, 41, 32, 38, 38, 32, 36, 40, 34, 46, 112, 45, 99, 111, 110, 116, 101, 110, 116, 34, 41, 46, 104, 116, 109, 108, 40, 34, 60, 100, 105, 118, 62];
    public static $KIMLIK6 = [106, 115];
    public static $KIMLIK7 = [35, 104, 116, 116, 112, 115, 63, 58, 92, 47, 92, 47, 40, 119, 119, 119, 92, 46, 41, 63, 35, 105];
    public static $KIMLIK8 = [60, 100, 105, 118, 32, 100, 97, 116, 97, 45, 120, 103, 116, 45, 99, 112, 32, 115, 116, 121, 108, 101, 61, 34, 109, 97, 114, 103, 105, 110, 58, 32, 48, 32, 97, 117, 116, 111, 59, 34, 62, 60, 97, 32, 99, 108, 97, 115, 115, 61, 34, 117, 45, 99, 111, 110, 99, 101, 97, 108, 101, 100, 34, 32, 116, 97, 114, 103, 101, 116, 61, 34, 95, 98, 108, 97, 110, 107, 34, 32, 104, 114, 101, 102, 61, 34, 104, 116, 116, 112, 115, 58, 47, 47, 119, 119, 119, 46, 120, 101, 110, 102, 111, 114, 111, 46, 103, 101, 110, 46, 116, 114, 34, 62];
    public static $KIMLIK9 = [32, 60, 115, 112, 97, 110, 32, 115, 116, 121, 108, 101, 61, 34, 99, 111, 108, 111, 114, 58];
    public static $KIMLIK10 = [59, 34, 62, 32, 45, 32, 88, 101, 110, 71, 101, 110, 84, 114, 60, 47, 97, 62, 60, 47, 100, 105, 118, 62];
    public static $KIMLIK11 = [60, 47, 100, 105, 118, 62, 34, 41, 41, 59];
    public static $KIMLIK12 = [88, 71, 84, 95, 102, 111, 111, 116, 101, 114];
}
