<?php

namespace XenGenTr\XGTForumistatistik\Widget;

class OneCikanKonular extends AbstractForumIstatistik
{
	/**
	 * @var mixed[]
	 */
	protected $defaultOptions = [
	 'limit' => 5,
        'excluded_node_ids' => [],
	];



	/**
	 * @return \XF\Widget\WidgetRenderer|null
	 */
	public function render()
	{

        $visitor = \XF::visitor();

        $options = $this->options;
        $limit = \XF::options()->xgtIstatistikGosterimLimiti;
        $nodeIds = $options['node_ids'];
        $excludedNodeIds = $options['excluded_node_ids'];



		$featureRepo = $this->getFeatureRepo();
		$finder = $featureRepo->findFeaturedContent();


		/** @var \XF\Mvc\Entity\ArrayCollection $features */
		$features = $finder->fetch(max($limit * 2, 10));
		$featureRepo->addContentToFeatures($features);



		$viewParams = [
			'features' => $features,

		];
		return $this->renderer('xgt_FrmIstatistik_oneCikanKonular', $viewParams);

	}


	/**
	 * @param \XF\Phrase|null $error
	 */
    public function verifyOptions(\XF\Http\Request $request, array &$options, &$error = null)
    {
        $options = $request->filter([
            'limit'             => 'uint',
            'excluded_node_ids' => 'array-uint',
        ]);

        if ($options['limit'] < 1)
        {
            $options['limit'] = 1;
        }

        if (in_array(0, $options['excluded_node_ids']))
        {
            $options['excluded_node_ids'] = [0];
        }

        return true;
    }

	protected function getFeatureRepo(): \XF\Repository\FeaturedContent
	{
		return $this->repository('XF:Featured');
	}
}